<div id="body" class="container-fluid">
  <h6>Set Qualifications</h6>
  <button class="btn btn-sm btn-primary mb-1" type="button"
          [disabled]="!selectedItemKeys.length" (click)="deleteRows()">
    Remove Selected Records
  </button>

  <dx-data-grid #grid id="grid" [dataSource]="items" keyExpr="qualificationID" [showBorders]="true"
                [rowAlternationEnabled]="true" [columnAutoWidth]="true" [wordWrapEnabled]="true"
                (onEditingStart)="onEditingStart($event)" (onInitNewRow)="onInitNewRow($event)"
                (onExporting)="onExporting($event)" (onExported)="onExported($event)"
                (onToolbarPreparing)="onToolbarPreparing($event)"
                (onSelectionChanged)="selectionChangedHandler($event)">
    <dxo-sorting mode="multiple"></dxo-sorting>
    <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
    <dxo-editing [useIcons]="true" [allowUpdating]="true" [allowAdding]="true"></dxo-editing>
    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
    <dxo-paging [pageSize]="50"></dxo-paging>
    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
    <dxi-column type="buttons" [buttons]="['edit']" caption="Edit"></dxi-column>
    <dxi-column type="buttons" caption="View" cellTemplate="viewButton"></dxi-column>
    <!-- Columns for Excel Export -->
    <dxi-column dataField="assignToUserAdId" caption="Assigned User Name"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="assignToUser" caption="Assigned User Display Name"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="customerNames" caption="Dedicated Customers"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="deviceNames" caption="sQualDev"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="enhanceServiceNames" caption="Enhanced Services"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="eventTypeNames" caption="Event Type"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="networkActivityNames" caption="Activity Type"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="ipVersionNames" caption="IP Version"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="specialProjectNames" caption="Special Projects"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="vendorModelNames" caption="Vendor Models"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="createdByAdId" caption="Created By User Name"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="createdByUser" caption="Created By Full Name"
                [visible]="false"></dxi-column>
    <dxi-column dataField="createdDate" caption="Created DateTime" dataType="string"
                [visible]="false" cellTemplate="localStartTime"></dxi-column>
    <dxi-column dataField="modifiedByAdId" caption="Modified By Username"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="modifiedByUser" caption="Modified By Full Name"
                dataType="string" [visible]="false"></dxi-column>
    <dxi-column dataField="modifiedDate" caption="Modified DateTime" dataType="string"
                [visible]="false" cellTemplate="localStartTime"></dxi-column>

    <!-- Columns showing on UI Table -->
    <dxi-column dataField="eventTypeNames" caption="Event Types" dataType="string"
                [allowHeaderFiltering]="true" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="networkActivityNames" caption="Activity Types" dataType="string"
                [allowHeaderFiltering]="true" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="enhanceServiceNames" caption="Enhanced Services" dataType="string"
                [allowHeaderFiltering]="true" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="assignToUser" caption="Assigned To" dataType="string"
                [allowHeaderFiltering]="true" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="createdByUser" caption="Created By" dataType="string"
                [allowHeaderFiltering]="false" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="modifiedByUser" caption="Modified By" dataType="string"
                [allowHeaderFiltering]="false" [allowExporting]="false"></dxi-column>
    <dxi-column dataField="modifiedDate" cellTemplate="localStartTime" caption="Modified Date"
                dataType="string" [allowHeaderFiltering]="false" [allowExporting]="false"></dxi-column>
    <div *dxTemplate="let cell of 'localStartTime'">
      <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
    </div>
    <div *dxTemplate="let data of 'searchTemplate'">
      <form [formGroup]="form" novalidate>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-24">
            <div class="col-24 col-lg-9 pl-0 pl-lg-1">
              <dx-select-box name="searchFilterCriteria" [items]="searchFilter" width="auto"
                             [showClearButton]="true" displayExpr="text" valueExpr="value"
                             formControlName="searchCriteria" placeholder="Select Criteria"
                             [searchEnabled]="true" [searchExpr]="['text']" searchMode="startswith">
              </dx-select-box>
            </div>
            <div class="col-24 col-lg-9 pl-0 pl-lg-1">
              <input #searchText name="searchText" type="text" placeholder="Search"
                     class="form-control form-control-sm" formControlName="searchText" />
            </div>
            <div class="col-24 col-lg-3 pl-0 pl-lg-1">
              <button class="btn btn-sm btn-primary" type="button" (click)="search()">Search</button>
            </div>
            <div class="col-24 col-lg-3 pl-0 pl-lg-1">
              <button class="btn btn-sm btn-secondary btn-block" type="button" (click)="clear()">Clear</button>
            </div>
          </div>
        </div>
      </form>
    </div>
    <div *dxTemplate="let data of 'exportTemplate'">
      <button type="button" class="btn btn-sm btn-primary"
              (click)="grid.instance.exportToExcel(false)">
        Export to Excel
      </button>
    </div>
    <div *dxTemplate="let data of 'viewButton'">
      <a class="dx-link dx-icon-more dx-link-icon" title="View" (click)="onViewClick(data)"></a>
    </div>
  </dx-data-grid>
</div>
